
/* autogenerated from mt19937arorc.orc */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef DISABLE_ORC
#include <orc/orc.h>
#endif

#ifndef _ORC_INTEGER_TYPEDEFS_
#define _ORC_INTEGER_TYPEDEFS_
#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
#include <stdint.h>
typedef int8_t orc_int8;
typedef int16_t orc_int16;
typedef int32_t orc_int32;
typedef int64_t orc_int64;
typedef uint8_t orc_uint8;
typedef uint16_t orc_uint16;
typedef uint32_t orc_uint32;
typedef uint64_t orc_uint64;
#define ORC_UINT64_C(x) UINT64_C(x)
#elif defined(_MSC_VER)
typedef signed __int8 orc_int8;
typedef signed __int16 orc_int16;
typedef signed __int32 orc_int32;
typedef signed __int64 orc_int64;
typedef unsigned __int8 orc_uint8;
typedef unsigned __int16 orc_uint16;
typedef unsigned __int32 orc_uint32;
typedef unsigned __int64 orc_uint64;
#define ORC_UINT64_C(x) (x##Ui64)
#else
#include <limits.h>
typedef signed char orc_int8;
typedef short orc_int16;
typedef int orc_int32;
typedef unsigned char orc_uint8;
typedef unsigned short orc_uint16;
typedef unsigned int orc_uint32;
#if INT_MAX == LONG_MAX
typedef long long orc_int64;
typedef unsigned long long orc_uint64;
#define ORC_UINT64_C(x) (x##ULL)
#else
typedef long orc_int64;
typedef unsigned long orc_uint64;
#define ORC_UINT64_C(x) (x##UL)
#endif
#endif
typedef union { orc_int16 i; orc_int8 x2[2]; } orc_union16;
typedef union { orc_int32 i; float f; orc_int16 x2[2]; orc_int8 x4[4]; } orc_union32;
typedef union { orc_int64 i; double f; orc_int32 x2[2]; float x2f[2]; orc_int16 x4[4]; } orc_union64;
#endif

void mt19937ar_mix (orc_uint32 * d1, const orc_uint32 * s1, const orc_uint32 * s2, int n);
void mt19937ar_temper (orc_uint32 * d1, const orc_uint32 * s1, int n);


/* begin Orc C target preamble */
#define ORC_CLAMP(x,a,b) ((x)<(a) ? (a) : ((x)>(b) ? (b) : (x)))
#define ORC_ABS(a) ((a)<0 ? -(a) : (a))
#define ORC_MIN(a,b) ((a)<(b) ? (a) : (b))
#define ORC_MAX(a,b) ((a)>(b) ? (a) : (b))
#define ORC_SB_MAX 127
#define ORC_SB_MIN (-1-ORC_SB_MAX)
#define ORC_UB_MAX 255
#define ORC_UB_MIN 0
#define ORC_SW_MAX 32767
#define ORC_SW_MIN (-1-ORC_SW_MAX)
#define ORC_UW_MAX 65535
#define ORC_UW_MIN 0
#define ORC_SL_MAX 2147483647
#define ORC_SL_MIN (-1-ORC_SL_MAX)
#define ORC_UL_MAX 4294967295U
#define ORC_UL_MIN 0
#define ORC_CLAMP_SB(x) ORC_CLAMP(x,ORC_SB_MIN,ORC_SB_MAX)
#define ORC_CLAMP_UB(x) ORC_CLAMP(x,ORC_UB_MIN,ORC_UB_MAX)
#define ORC_CLAMP_SW(x) ORC_CLAMP(x,ORC_SW_MIN,ORC_SW_MAX)
#define ORC_CLAMP_UW(x) ORC_CLAMP(x,ORC_UW_MIN,ORC_UW_MAX)
#define ORC_CLAMP_SL(x) ORC_CLAMP(x,ORC_SL_MIN,ORC_SL_MAX)
#define ORC_CLAMP_UL(x) ORC_CLAMP(x,ORC_UL_MIN,ORC_UL_MAX)
#define ORC_SWAP_W(x) ((((x)&0xff)<<8) | (((x)&0xff00)>>8))
#define ORC_SWAP_L(x) ((((x)&0xff)<<24) | (((x)&0xff00)<<8) | (((x)&0xff0000)>>8) | (((x)&0xff000000)>>24))
#define ORC_SWAP_Q(x) ((((x)&ORC_UINT64_C(0xff))<<56) | (((x)&ORC_UINT64_C(0xff00))<<40) | (((x)&ORC_UINT64_C(0xff0000))<<24) | (((x)&ORC_UINT64_C(0xff000000))<<8) | (((x)&ORC_UINT64_C(0xff00000000))>>8) | (((x)&ORC_UINT64_C(0xff0000000000))>>24) | (((x)&ORC_UINT64_C(0xff000000000000))>>40) | (((x)&ORC_UINT64_C(0xff00000000000000))>>56))
#define ORC_PTR_OFFSET(ptr,offset) ((void *)(((unsigned char *)(ptr)) + (offset)))
#define ORC_DENORMAL(x) ((x) & ((((x)&0x7f800000) == 0) ? 0xff800000 : 0xffffffff))
#define ORC_ISNAN(x) ((((x)&0x7f800000) == 0x7f800000) && (((x)&0x007fffff) != 0))
#define ORC_DENORMAL_DOUBLE(x) ((x) & ((((x)&ORC_UINT64_C(0x7ff0000000000000)) == 0) ? ORC_UINT64_C(0xfff0000000000000) : ORC_UINT64_C(0xffffffffffffffff)))
#define ORC_ISNAN_DOUBLE(x) ((((x)&ORC_UINT64_C(0x7ff0000000000000)) == ORC_UINT64_C(0x7ff0000000000000)) && (((x)&ORC_UINT64_C(0x000fffffffffffff)) != 0))
#if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
#define ORC_RESTRICT restrict
#elif defined(__GNUC__) && __GNUC__ >= 4
#define ORC_RESTRICT __restrict__
#else
#define ORC_RESTRICT
#endif
/* end Orc C target preamble */



/* mt19937ar_mix */
#ifdef DISABLE_ORC
void
mt19937ar_mix (orc_uint32 * d1, const orc_uint32 * s1, const orc_uint32 * s2, int n){
  int i;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  const orc_union32 * ORC_RESTRICT ptr5;
  orc_union32 var35;
  orc_union32 var36;
  orc_union32 var37;
  orc_union32 var38;
  orc_union32 var39;
  orc_union32 var40;
  orc_union32 var41;
  orc_union32 var42;
  orc_union32 var43;
  orc_union32 var44;
  orc_union32 var45;
  orc_union32 var46;
  orc_union32 var47;
  orc_union32 var48;
  orc_union32 var49;
  orc_union32 var50;
  orc_union32 var51;

  ptr0 = (orc_union32 *)d1;
  ptr4 = (orc_union32 *)s1;
  ptr5 = (orc_union32 *)s2;

    /* 1: loadpl */
    var35.i = 0x80000000; /* -2147483648 or 1.061e-314f */
    /* 4: loadpl */
    var36.i = 0x7fffffff; /* 2147483647 or 1.061e-314f */
    /* 7: loadpl */
    var37.i = 0x00000001; /* 1 or 4.94066e-324f */
    /* 9: loadpl */
    var38.i = 0x00000001; /* 1 or 4.94066e-324f */
    /* 11: loadpl */
    var39.i = 0x9908b0df; /* -1727483681 or 1.26851e-314f */

  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var42 = ptr0[i];
    /* 2: andl */
    var43.i = var42.i & var35.i;
    /* 3: loadl */
    var44 = ptr4[i];
    /* 5: andl */
    var45.i = var44.i & var36.i;
    /* 6: orl */
    var46.i = var43.i | var45.i;
    /* 8: andl */
    var47.i = var46.i & var37.i;
    /* 10: cmpeql */
    var48.i = (var47.i == var38.i) ? (~0) : 0;
    /* 12: andl */
    var49.i = var48.i & var39.i;
    /* 13: shrul */
    var50.i = ((orc_uint32)var46.i) >> 1;
    /* 14: xorl */
    var51.i = var50.i ^ var49.i;
    /* 15: loadl */
    var40 = ptr5[i];
    /* 16: xorl */
    var41.i = var40.i ^ var51.i;
    /* 17: storel */
    ptr0[i] = var41;
  }

}

#else
static void
_backup_mt19937ar_mix (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  const orc_union32 * ORC_RESTRICT ptr5;
  orc_union32 var35;
  orc_union32 var36;
  orc_union32 var37;
  orc_union32 var38;
  orc_union32 var39;
  orc_union32 var40;
  orc_union32 var41;
  orc_union32 var42;
  orc_union32 var43;
  orc_union32 var44;
  orc_union32 var45;
  orc_union32 var46;
  orc_union32 var47;
  orc_union32 var48;
  orc_union32 var49;
  orc_union32 var50;
  orc_union32 var51;

  ptr0 = (orc_union32 *)ex->arrays[0];
  ptr4 = (orc_union32 *)ex->arrays[4];
  ptr5 = (orc_union32 *)ex->arrays[5];

    /* 1: loadpl */
    var35.i = 0x80000000; /* -2147483648 or 1.061e-314f */
    /* 4: loadpl */
    var36.i = 0x7fffffff; /* 2147483647 or 1.061e-314f */
    /* 7: loadpl */
    var37.i = 0x00000001; /* 1 or 4.94066e-324f */
    /* 9: loadpl */
    var38.i = 0x00000001; /* 1 or 4.94066e-324f */
    /* 11: loadpl */
    var39.i = 0x9908b0df; /* -1727483681 or 1.26851e-314f */

  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var42 = ptr0[i];
    /* 2: andl */
    var43.i = var42.i & var35.i;
    /* 3: loadl */
    var44 = ptr4[i];
    /* 5: andl */
    var45.i = var44.i & var36.i;
    /* 6: orl */
    var46.i = var43.i | var45.i;
    /* 8: andl */
    var47.i = var46.i & var37.i;
    /* 10: cmpeql */
    var48.i = (var47.i == var38.i) ? (~0) : 0;
    /* 12: andl */
    var49.i = var48.i & var39.i;
    /* 13: shrul */
    var50.i = ((orc_uint32)var46.i) >> 1;
    /* 14: xorl */
    var51.i = var50.i ^ var49.i;
    /* 15: loadl */
    var40 = ptr5[i];
    /* 16: xorl */
    var41.i = var40.i ^ var51.i;
    /* 17: storel */
    ptr0[i] = var41;
  }

}

void
mt19937ar_mix (orc_uint32 * d1, const orc_uint32 * s1, const orc_uint32 * s2, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static int p_inited = 0;
  static OrcProgram *p = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcCompileResult result;

      p = orc_program_new ();
      orc_program_set_name (p, "mt19937ar_mix");
      orc_program_set_backup_function (p, _backup_mt19937ar_mix);
      orc_program_add_destination (p, 4, "d1");
      orc_program_add_source (p, 4, "s1");
      orc_program_add_source (p, 4, "s2");
      orc_program_add_constant (p, 4, 0x00000001, "c1");
      orc_program_add_constant (p, 4, 0x80000000, "c2");
      orc_program_add_constant (p, 4, 0x7fffffff, "c3");
      orc_program_add_constant (p, 4, 0x9908b0df, "c4");
      orc_program_add_temporary (p, 4, "t1");
      orc_program_add_temporary (p, 4, "t2");
      orc_program_add_temporary (p, 4, "t3");

      orc_program_append_2 (p, "loadl", 0, ORC_VAR_T2, ORC_VAR_D1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "andl", 0, ORC_VAR_T2, ORC_VAR_T2, ORC_VAR_C2, ORC_VAR_D1);
      orc_program_append_2 (p, "loadl", 0, ORC_VAR_T3, ORC_VAR_S1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "andl", 0, ORC_VAR_T3, ORC_VAR_T3, ORC_VAR_C3, ORC_VAR_D1);
      orc_program_append_2 (p, "orl", 0, ORC_VAR_T1, ORC_VAR_T2, ORC_VAR_T3, ORC_VAR_D1);
      orc_program_append_2 (p, "andl", 0, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_C1, ORC_VAR_D1);
      orc_program_append_2 (p, "cmpeql", 0, ORC_VAR_T2, ORC_VAR_T2, ORC_VAR_C1, ORC_VAR_D1);
      orc_program_append_2 (p, "andl", 0, ORC_VAR_T2, ORC_VAR_T2, ORC_VAR_C4, ORC_VAR_D1);
      orc_program_append_2 (p, "shrul", 0, ORC_VAR_T1, ORC_VAR_T1, ORC_VAR_C1, ORC_VAR_D1);
      orc_program_append_2 (p, "xorl", 0, ORC_VAR_T1, ORC_VAR_T1, ORC_VAR_T2, ORC_VAR_D1);
      orc_program_append_2 (p, "xorl", 0, ORC_VAR_D1, ORC_VAR_S2, ORC_VAR_T1, ORC_VAR_D1);

      result = orc_program_compile (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->program = p;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->arrays[ORC_VAR_S1] = (void *)s1;
  ex->arrays[ORC_VAR_S2] = (void *)s2;

  func = p->code_exec;
  func (ex);
}
#endif


/* mt19937ar_temper */
#ifdef DISABLE_ORC
void
mt19937ar_temper (orc_uint32 * d1, const orc_uint32 * s1, int n){
  int i;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var34;
  orc_union32 var35;
  orc_union32 var36;
  orc_union32 var37;
  orc_union32 var38;
  orc_union32 var39;
  orc_union32 var40;
  orc_union32 var41;
  orc_union32 var42;
  orc_union32 var43;
  orc_union32 var44;
  orc_union32 var45;
  orc_union32 var46;

  ptr0 = (orc_union32 *)d1;
  ptr4 = (orc_union32 *)s1;

    /* 4: loadpl */
    var34.i = 0x9d2c5680; /* -1658038656 or 1.30282e-314f */
    /* 8: loadpl */
    var35.i = 0xefc60000; /* -272236544 or 1.98749e-314f */

  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var37 = ptr4[i];
    /* 1: shrul */
    var38.i = ((orc_uint32)var37.i) >> 11;
    /* 2: xorl */
    var39.i = var37.i ^ var38.i;
    /* 3: shll */
    var40.i = var39.i << 7;
    /* 5: andl */
    var41.i = var40.i & var34.i;
    /* 6: xorl */
    var42.i = var39.i ^ var41.i;
    /* 7: shll */
    var43.i = var42.i << 15;
    /* 9: andl */
    var44.i = var43.i & var35.i;
    /* 10: xorl */
    var45.i = var42.i ^ var44.i;
    /* 11: shrul */
    var46.i = ((orc_uint32)var45.i) >> 18;
    /* 12: xorl */
    var36.i = var45.i ^ var46.i;
    /* 13: storel */
    ptr0[i] = var36;
  }

}

#else
static void
_backup_mt19937ar_temper (OrcExecutor * ORC_RESTRICT ex)
{
  int i;
  int n = ex->n;
  orc_union32 * ORC_RESTRICT ptr0;
  const orc_union32 * ORC_RESTRICT ptr4;
  orc_union32 var34;
  orc_union32 var35;
  orc_union32 var36;
  orc_union32 var37;
  orc_union32 var38;
  orc_union32 var39;
  orc_union32 var40;
  orc_union32 var41;
  orc_union32 var42;
  orc_union32 var43;
  orc_union32 var44;
  orc_union32 var45;
  orc_union32 var46;

  ptr0 = (orc_union32 *)ex->arrays[0];
  ptr4 = (orc_union32 *)ex->arrays[4];

    /* 4: loadpl */
    var34.i = 0x9d2c5680; /* -1658038656 or 1.30282e-314f */
    /* 8: loadpl */
    var35.i = 0xefc60000; /* -272236544 or 1.98749e-314f */

  for (i = 0; i < n; i++) {
    /* 0: loadl */
    var37 = ptr4[i];
    /* 1: shrul */
    var38.i = ((orc_uint32)var37.i) >> 11;
    /* 2: xorl */
    var39.i = var37.i ^ var38.i;
    /* 3: shll */
    var40.i = var39.i << 7;
    /* 5: andl */
    var41.i = var40.i & var34.i;
    /* 6: xorl */
    var42.i = var39.i ^ var41.i;
    /* 7: shll */
    var43.i = var42.i << 15;
    /* 9: andl */
    var44.i = var43.i & var35.i;
    /* 10: xorl */
    var45.i = var42.i ^ var44.i;
    /* 11: shrul */
    var46.i = ((orc_uint32)var45.i) >> 18;
    /* 12: xorl */
    var36.i = var45.i ^ var46.i;
    /* 13: storel */
    ptr0[i] = var36;
  }

}

void
mt19937ar_temper (orc_uint32 * d1, const orc_uint32 * s1, int n)
{
  OrcExecutor _ex, *ex = &_ex;
  static int p_inited = 0;
  static OrcProgram *p = 0;
  void (*func) (OrcExecutor *);

  if (!p_inited) {
    orc_once_mutex_lock ();
    if (!p_inited) {
      OrcCompileResult result;

      p = orc_program_new ();
      orc_program_set_name (p, "mt19937ar_temper");
      orc_program_set_backup_function (p, _backup_mt19937ar_temper);
      orc_program_add_destination (p, 4, "d1");
      orc_program_add_source (p, 4, "s1");
      orc_program_add_constant (p, 4, 0x0000000b, "c1");
      orc_program_add_constant (p, 4, 0x00000007, "c2");
      orc_program_add_constant (p, 4, 0x9d2c5680, "c3");
      orc_program_add_constant (p, 4, 0x0000000f, "c4");
      orc_program_add_constant (p, 4, 0xefc60000, "c5");
      orc_program_add_constant (p, 4, 0x00000012, "c6");
      orc_program_add_temporary (p, 4, "t1");
      orc_program_add_temporary (p, 4, "t2");

      orc_program_append_2 (p, "loadl", 0, ORC_VAR_T1, ORC_VAR_S1, ORC_VAR_D1, ORC_VAR_D1);
      orc_program_append_2 (p, "shrul", 0, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_C1, ORC_VAR_D1);
      orc_program_append_2 (p, "xorl", 0, ORC_VAR_T1, ORC_VAR_T1, ORC_VAR_T2, ORC_VAR_D1);
      orc_program_append_2 (p, "shll", 0, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_C2, ORC_VAR_D1);
      orc_program_append_2 (p, "andl", 0, ORC_VAR_T2, ORC_VAR_T2, ORC_VAR_C3, ORC_VAR_D1);
      orc_program_append_2 (p, "xorl", 0, ORC_VAR_T1, ORC_VAR_T1, ORC_VAR_T2, ORC_VAR_D1);
      orc_program_append_2 (p, "shll", 0, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_C4, ORC_VAR_D1);
      orc_program_append_2 (p, "andl", 0, ORC_VAR_T2, ORC_VAR_T2, ORC_VAR_C5, ORC_VAR_D1);
      orc_program_append_2 (p, "xorl", 0, ORC_VAR_T1, ORC_VAR_T1, ORC_VAR_T2, ORC_VAR_D1);
      orc_program_append_2 (p, "shrul", 0, ORC_VAR_T2, ORC_VAR_T1, ORC_VAR_C6, ORC_VAR_D1);
      orc_program_append_2 (p, "xorl", 0, ORC_VAR_D1, ORC_VAR_T1, ORC_VAR_T2, ORC_VAR_D1);

      result = orc_program_compile (p);
    }
    p_inited = TRUE;
    orc_once_mutex_unlock ();
  }
  ex->program = p;

  ex->n = n;
  ex->arrays[ORC_VAR_D1] = d1;
  ex->arrays[ORC_VAR_S1] = (void *)s1;

  func = p->code_exec;
  func (ex);
}
#endif


